package org.rcisoft.wechat.service;

import me.chanjar.weixin.common.bean.WxJsapiSignature;
import me.chanjar.weixin.common.exception.WxErrorException;
import me.chanjar.weixin.mp.api.WxMpInMemoryConfigStorage;
import me.chanjar.weixin.mp.api.impl.WxMpServiceImpl;
import me.chanjar.weixin.mp.bean.result.WxMpOAuth2AccessToken;
import me.chanjar.weixin.mp.bean.result.WxMpUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 获取微信用户信息
 * @author david
 */
@Service
public class WxPortalService extends WxMpServiceImpl {

    @Value("${wechat.mp.appId}")
    String appId;

    @Value("${wechat.mp.secret}")
    String secret;

    @Value("${wechat.mp.token}")
    String token;

    @Value("${wechat.mp.aesKey}")
    String aesKey;

    private final Logger logger = LoggerFactory.getLogger(this.getClass());
    public WxPortalService() {
    }
    @PostConstruct
    public void init() {
        WxMpInMemoryConfigStorage config = new WxMpInMemoryConfigStorage();
        config.setAppId(appId);
        config.setSecret(secret);
        config.setToken(token);
        config.setAesKey(aesKey);
        super.setWxMpConfigStorage(config);
    }
    public WxMpOAuth2AccessToken oauth2AccessToken(String code) throws WxErrorException {
        WxMpOAuth2AccessToken token = this.oauth2getAccessToken(code);
        System.out.println("token:" + token.getAccessToken() + "; code: " + code);
        return token;
    }
    public WxMpUser oauth2UserInfo(String code) throws WxErrorException {
        WxMpOAuth2AccessToken token = this.oauth2AccessToken(code);
        return token != null?this.oauth2getUserInfo(token, (String)null):null;
    }
    public WxJsapiSignature getJsApiTicket(String url) throws WxErrorException {
        return this.createJsapiSignature(url);
    }

}
